
#!/usr/bin/env perl

my $DIM=shift;

my $base="cube-$DIM-orb";

my $GAP="\$HOME/config/scripts/gap-acenet";
$GAP="\$HOME/config/scripts/gap";

print "
#\$ -S /bin/sh
#\$ -cwd
#\$ -e $base-err-\$JOB_ID
#\$ -o $base-out-\$JOB_ID
#\$ -N $base

GAP_EXTRALIB=\$HOME/research/symbal
export GAP_EXTRALIB
LD_LIBRARY_PATH=\$HOME/lib
export LD_LIBRARY_PATH

$GAP -o 4G <<MAGICEOFSTRING
";
print '
RequirePackage("require_file");;
AddToLoadPath("~/research/gap-lrslib/src");;
AddToLoadPath("../cube");;
ReadFile("cube.gap");;
';
print "d:=$DIM;;\n";
print "name:=\"cube-$DIM-basis-orbs\";;\n";

print '
V:=CubeVerts(d);;
G:=orthoPermGroup(d);;
bases:=Filtered(Combinations([1..2^d],d+1),l->RankMat(V{l})=d+1);;

orbs:=OrbitLengths(G,bases,OnSets);
PrintTo(name,"#STARTRESULTS\n");;
';

print "AppendTo(name,\"{'dimension'=> $DIM, \\n\");\n";;
print 'AppendTo(name,"\'key\'=>\'dimension\',\n");;
AppendTo(name, " \'bases\'=> ",Size(bases),",\n");;
AppendTo(name," \'orbits\'=>",Size(orbs),"}\n");;
AppendTo(name,"#ENDRESULTS\n");;
MAGICEOFSTRING
';
