RequirePackage("require_file");
AddToLoadPath("~/research/symbal/src");
AddToLoadPath("../cut");

ReadFile("dfs.gap");
ReadFile("perturb.gap");

Read("E7-verts.gap");
Read("E7-group.gap");

lat:=LatticeByCyclicExtension(G,function(g) return Size(g)<=100; end);
lg:=Filtered(List(ConjugacyClassesSubgroups(lat),Representative),
            g->Size(g)>1 and Size(Orbits(g,[1..Size(V)]))>1);


for i in [1..Size(lg)] do
    gog:=SmallGeneratingSet(lg[i]);
    nameg:=Concatenation("E7-small-",String(i),"-group.gap");
    namev:=Concatenation("E7-small-",String(i),"-verts.gap");
    PrintTo(nameg,"gog:=",gog,";\n");
    AppendTo(nameg,"G:=Group(gog);\n");
    Vp:=orbitLex2(V,Group(gog),DefaultInnerProduct,1/1000000);
    PrintTo(namev,"V:=",Vp.matrix,";;\n");
od;
    