
# some simple functions to transfer back and forth between matrix and 
# permutation group 


######################################################################

LinearMapPerm:=function(pi,A)
    local iCols,dCols,Aprime,Atranspose,dim,B,T;
    
    dim:=Size(A[1]);
    
    iCols:=LinearIndependentColumns(A);
    dCols:=Difference([1..Size(A[1])],iCols);
    Info(InfoDFS,5,"Dependent columns= ",dCols);
    # Augment A to be full column rank.
    Aprime:=Concatenation(A,IdentityMat(dim){dCols});
    Info(InfoDFS,5,"Augmented A Matrix= ",Aprime);
    
    Atranspose:=TransposedMat(Aprime);
    
    B:=Aprime{Permuted([1..Size(Aprime)],pi)};
    
    # do the left inverse trick.  
    #Print(1/(Atranspose*Aprime));
    return (1/(Atranspose*Aprime))*(Atranspose*B);
end;

PermLinearMap:=function(T,M)
    local newM;
    newM:=M*T;
#    Info(InfoDFS,2,newM);
    return PermList(List(M,v->Position(newM,v)));
end;


PermGroupMatGroup:=function(G,Mat)
    return Group(List(GeneratorsOfGroup(G),
                         T->PermLinearMap(T,Mat)));
end;

MatGroupPermGroup:=function(G,Mat)
    local gog,Mgog;
    
    gog:=GeneratorsOfGroup(G);
    Info(InfoDFS,4,"Perm Group Generators ",gog);
    Mgog:=List(gog, p->LinearMapPerm(p,Mat));
    Info(InfoDFS,4,"...As Matrices ",Mgog);
    return Group(Mgog);
end;

######################################################################

